/*
 * oscp-slave-asap.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "oscp-slave.h"
#include <asap.h>

ASAP *asapc; ASAPInfo *asapI;

int asapstate=0; float asapcur=0, asapdur=0; int asapi=0;

/////################
void asap_show_supp() {
 printf("  [slave-asap]: based on asap-3.2.0");
 printf(", formats: sap, cm3, cmc, cmr, cms, dmc, dlt, mpd, mpt, rmt, tm2, tm8, tmc, fc\n");
}

/////###########
//void asap_flush() { lf("asap_flush"); adev_flush(); }
/////###########
void asap_init() { lf("asap_init"); asapstate=0; dlog(9, "asap_init"); if(asapstate>0) return;

 if(asapc) dlog(9, "asap_init: asapc not null?");
 asapc=ASAP_New();
// asapI=ASAPInfo_New();
 ASAP_DetectSilence(asapc, 5);

 if(adev_init()<=0) { asapstate=0; return; }

 asapstate=1;
}
/////##########
void asap_stop() { lf("asap_stop");
 dlog(9, "asap_stop");
 if(asapstate<=1) return;

 if(asapstate>=3) { 
//  if(asapI) ASAPInfo_Delete(asapI);
//if(asapI) dlog(9,"ERRRR: it should be undefined now"); else dlog(9,"OKKKK: deleted");
 }

 asapstate=1;
}
/////#########
void asap_end() { lf("asap_end");
 dlog(9, "asap_end"); if(asapstate>1) asap_stop(); adev_end();
// if(asapI) ASAPInfo_Delete(asapI);
 if(asapc) ASAP_Delete(asapc);
 asapstate=0; 
}
/////##################
void asap_die(char *msg) { lf2("asap_die",msg); dlog(9, "asap_die"); asap_stop(); cs(msg); }

/////#########################
void asap_update_info(char *fn) { lf2("asap_update_info", fn); static char lmsg[4096];
 int i;

 snprintf(lmsg,4095,"Artist: %s\n", ASAPInfo_GetAuthor(asapI)); cs(lmsg);
// snprintf(lmsg,4095,"Title: %s\n", ASAPInfo_GetTitleOrFilename(asapI)); cs(lmsg);
 snprintf(lmsg,4095,"Title: %s (%s)\n", ASAPInfo_GetTitle(asapI), get_basename(fn)); cs(lmsg);
 i=ASAPInfo_GetYear(asapI); if(i>0) { snprintf(lmsg,128,"Year: %d\n", i); cs(lmsg); }

//if(asapmi.comment) snprintf(lmsg,4095,"Comment: %d, %d, %s, %s\n", fs, asapmi.num_sequences,
// asapmi.mod->type, asapmi.comment);
//else snprintf(lmsg,4095,"Comment: %d, %d, %s\n", fs, asapmi.num_sequences, asapmi.mod->type); cs(lmsg);
 sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels, 0); cs(lmsg);

/*
struct ASAPInfo { int channels; int covoxAddr; int defaultSong; int fastplay; int headerLen;
 int init; int music; cibool ntsc; int player; int songs; ASAPModuleType type;
 unsigned char songPos[32]; char author[128]; char date[128]; int durations[32];
 char filename[128]; cibool loops[32]; char title[128]; };

ASAPInfo const *ASAP_GetInfo(ASAP const *self);
ASAPInfo *ASAPInfo_New(void);
void ASAPInfo_Delete(ASAPInfo *self);
const char *ASAPInfo_GetAuthor(ASAPInfo const *self);
int ASAPInfo_GetChannels(ASAPInfo const *self);
const char *ASAPInfo_GetDate(ASAPInfo const *self);
//int ASAPInfo_GetDefaultSong(ASAPInfo const *self);
//int ASAPInfo_GetDuration(ASAPInfo const *self, int song); in ms
//int ASAPInfo_GetSongs(ASAPInfo const *self);
const char *ASAPInfo_GetTitleOrFilename(ASAPInfo const *self);
int ASAPInfo_GetYear(ASAPInfo const *self);
cibool ASAPInfo_IsNtsc(ASAPInfo const *self);
cibool ASAPInfo_Load(ASAPInfo *self, const char *filename, unsigned char const *module, int moduleLen);

 int fs=get_filesize(fn); sprintf(lmsg,"fs: %d",fs); dlog(9,lmsg);
 char *bn=rindex(fn, *"/"); if(!bn) bn=fn; else bn++;

 struct asap_module_info asapmi;
 asap_get_module_info(asapc, &asapmi);
//snprintf(lmsg,4095,"asapmi: md5: %s", asapmi.md5); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: vol_base: %d", asapmi.vol_base); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: comment: %s", asapmi.comment); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: num_seq: %d", asapmi.num_sequences); dlog(9,lmsg);
if(asapmi.mod->name) { snprintf(lmsg,4095,"Title: %s\n", asapmi.mod->name); cs(lmsg); }
if(bn) { snprintf(lmsg,4095,"Artist: %s\n", bn); cs(lmsg); }

if(asapmi.comment) snprintf(lmsg,4095,"Comment: %d, %d, %s, %s\n", fs, asapmi.num_sequences,
 asapmi.mod->type, asapmi.comment);
else snprintf(lmsg,4095,"Comment: %d, %d, %s\n", fs, asapmi.num_sequences, asapmi.mod->type); cs(lmsg);
//snprintf(lmsg,4095,"asapmi: pat: %d", asapmi.mod->pat); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: trk: %d", asapmi.mod->trk); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: chn: %d", asapmi.mod->chn); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: ins: %d", asapmi.mod->ins); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: smp: %d", asapmi.mod->smp); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: spd: %d", asapmi.mod->spd); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: bpm: %d", asapmi.mod->bpm); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: len: %d", asapmi.mod->len); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: rst: %d", asapmi.mod->rst); dlog(9,lmsg);
//snprintf(lmsg,4095,"asapmi: gvl: %d", asapmi.mod->gvl); dlog(9,lmsg);
 sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels,
  7); cs(lmsg);
*/

/*if(0==strcmp(tag->key,"artist")) { snprintf(lmsg,1022,"Artist: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"title")) { snprintf(lmsg,1022,"Title: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"album")) { snprintf(lmsg,1022,"Album: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"comment")) { snprintf(lmsg,1022,"Comment: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"genre")) { snprintf(lmsg,1022,"Genre  : %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"date")) { snprintf(lmsg,1022,"Year: %s\n",tag->value); cs(lmsg); }

  else if(0==strcmp(tag->key,"StreamTitle")) { snprintf(lmsg,1022,"Title: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"icy-genre")) { snprintf(lmsg,1022,"Genre  : %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"icy-name")) { snprintf(lmsg,1022,"Comment: %s\n",tag->value); cs(lmsg); }
snprintf(lmsg, 1022, "asap_update_info: %s=%s", tag->key, tag->value); dlog(9,lmsg);
*/
}

////######################
int asap_tryload(char *fn) { if(fn[0]==0) return -1;  int fs=get_filesize(fn);
 if(fs<=0 || fs>20*1024*1024) { asap_die("EOF code: module too small/big\n"); return -2; }
 char *module=malloc(fs); if(!module) { return -3; }
 FILE *f=fopen(fn,"r"); if(!f) { free(module); return -4; } fread(module, fs, 1, f); fclose(f);
 static ASAP *c; if(!c) c=ASAP_New(); if(!c) { free(module); return -5; }
 if(ASAP_Load(c,fn,(const unsigned char *)module,fs)==0){free(module);ASAP_Delete(c);return -6;}
 free(module); ASAP_Delete(c); return 0;
}

void asap_play();
/////################################
void asap_load(char *input_filename0) { lfd("asap_load: asapstate",asapstate);
 static char lmsg[4096]; lmsg[4095]=0;
 snprintf(lmsg, 4095, "Playing %s\n", input_filename0); cs(lmsg);

 if(input_filename0[0]==0) return;
 if(input_filename0[0]==*"\"" && input_filename0[1]==*"\"" && input_filename0[2]==0)
 { cs("EOF code: stop requested\n"); if(asapstate>2) asap_stop(); return; }

 if(asapstate==0) asap_init();
 else if(asapstate>2) asap_stop();

 asapstate=2; asapcur=0; asapdur=0;
 char *input_filename=input_filename0;


// if(ASAPInfo_IsOurFile(input_filename)==0)
// { dlog(9,"asap_load not asap file"); asap_die("EOF code: asap_load_module failed\n"); return; }

 unsigned char *module;

 int fs=get_filesize(input_filename);
 if(fs<=0 || fs>256*1024) { asap_die("EOF code: module too small/big\n"); return; }
 module=malloc(fs); if(!module) { asap_die("EOF code: malloc failed\n"); return; }

 FILE *f=fopen(input_filename,"r"); if(f) { fread(module, fs, 1, f); fclose(f); }
 else { free(module); asap_die("EOF code: fread failed\n"); return; }

 if(ASAP_Load(asapc, input_filename, module, fs)==0) { if(module) free(module);
  dlog(9,"asap_load failed"); asap_die("EOF code: asap_load_module failed\n"); return; }
 if(module) free(module);

// if(asapI) ASAPInfo_Delete(asapI);
 if(!asapI) asapI=(ASAPInfo *)ASAP_GetInfo(asapc);

 sfmt=AV_SAMPLE_FMT_S16;
      if(sfmt==AV_SAMPLE_FMT_U8 || sfmt==AV_SAMPLE_FMT_U8P){ sformat.bits=8; }
 else if(sfmt==AV_SAMPLE_FMT_S16 || sfmt==AV_SAMPLE_FMT_S16P){ sformat.bits=16; }
 else if(sfmt==AV_SAMPLE_FMT_S32 || sfmt==AV_SAMPLE_FMT_S32P){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_FLT || sfmt==AV_SAMPLE_FMT_FLTP){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_DBL || sfmt==AV_SAMPLE_FMT_DBLP){ sformat.bits=64; }
 else { asap_die("EOF code: Unsupported format\n"); return; }

//struct ASAPInfo { int channels; int covoxAddr; int defaultSong; int fastplay; int headerLen;
// int init; int music; cibool ntsc; int player; int songs; ASAPModuleType type;
// unsigned char songPos[32]; char author[128]; char date[128]; int durations[32];
// char filename[128]; cibool loops[32]; char title[128]; };

 if(ASAP_PlaySong(asapc, ASAPInfo_GetDefaultSong(asapI), 360000)==0)
 { dlog(9, "asap_load: ASAP_PlaySong failed"); }

 asapcur=-1; asapdur=ASAPInfo_GetDuration(asapI, ASAPInfo_GetDefaultSong(asapI))/1000.0;
 sprintf(lmsg, "ANS_length=%.1f\n", asapdur); cs(lmsg);

 sformat.channels=ASAPInfo_GetChannels(asapI); sformat.rate=ASAP_SAMPLE_RATE;
#ifdef LAO
 sformat.byte_format=AO_FMT_NATIVE; sformat.matrix=0;
#endif

 adev_setp(sformat.bits, &sformat.channels, &sformat.rate);

 asap_update_info(input_filename);

 asapstate=3; asapi=1;
 asap_play();
}
void oscp_asap_check_input();
void oscp_asap_parse(char *a);
/////################# check messages
void asap_check_input() { lf("asap_check_input"); static char lmsg[4096]; static int rc;
 static fd_set asapfsa;  static struct timeval asaptv,*tvp;
 if(asapstate==4) { tvp=NULL; }
 else { asaptv.tv_sec=0; asaptv.tv_usec=1; tvp=&asaptv; }

 FD_ZERO(&asapfsa); if(parent_said>=0) FD_SET(parent_said, &asapfsa);

 rc=select(FD_SETSIZE, &asapfsa, NULL, NULL, tvp); if(rc==0) return;
 else if(rc<0) { sprintf(lmsg, "Info: asapci rc<0, %d, %s\n", errno, strerror(errno)); cs(lmsg); }
 else if(rc>0) // check if input is available
 { fdreadline(parent_said, lmsg, 1020); oscp_asap_parse(lmsg); }
}
/////###################
void asap_pause_toggle() { lf("asap_pause_toggle");
      if(asapstate==3) { asapstate=4; cs("===== PAUSE =====\n");
  do { oscp_asap_check_input(); } while(asapstate==4);
 }
 else if(asapstate==4) { asapstate=3; cs("===== RESUME =====\n"); }
 else cs("Info: pause called but asapstate != (3 || 4)"); }

/////##############
void asap_checksd() {}
/////##############
void asap_checkmd() {}

// decode buffer
unsigned char asap_dbuf[1024*192];

/////###########
void asap_play() { lf("asap_play"); dlog(9, "asap_play");
 if(asapstate!=3) { cs("EOF code: can't play, not inited\n"); return; }
 int t1=0,ot1=-1; // asapcur=0; asapdur=0;
 static char lmsg[128];
 void *buf[1];

// ASAP_PlaySong(asapc, 0, 360000);
//dlog(9,"DIIING");
 int gb;

 while(asapstate==3 && (gb=ASAP_Generate(asapc, asap_dbuf, 1024*4, ASAPSampleFormat_S16_L_E))>0)
 {
//sprintf(lmsg,"gb: %d, gb/4:%d", gb, gb/4); dlog(9,lmsg);
//dlog(9,"DOOONG");

  t1=ASAP_GetPosition(asapc)/1000; if(t1!=ot1)
  { ot1=t1; asapcur=t1; sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0\n", asapcur); cs(lmsg);

//   if(asapdur==0) { asapdur=asapfi.total_time/1000.0; sprintf(lmsg, "ANS_length=%.1f\n", asapdur); cs(lmsg); }
  }

//int     ASAP_Generate(ASAP *self, unsigned char *buffer, int bufferLen, ASAPSampleFormat format);

  buf[0]=asap_dbuf;
  adev_out(buf, gb/2/sformat.channels, sformat.channels, sfmt);

#if 0
if(0&&ot2==1) { // static char lmsg[1024]; sprintf(lmsg,
 "Info: fmt:%s, ch:%d, bi:%d, ra:%d, len:%d, plane_size: %d",
 lfmt, sformat.channels, sformat.bits, sformat.rate, len, plane_size); dlog(9,lmsg); }
#endif

  asapi++; asap_check_input();
 }
 

 adev_close();
 asap_die("EOF code: finished decoding\n");
 lf("asap_play:finished");
}

/////##########################
void oscp_asap_load(char *fn) { lf("oscp_asap_load");
 asap_load(fn); //asap_play();
 lf("oscp_asap_load:finished");
}
/////####################
void oscp_asap_seek(int a) { lf("oscp_asap_seek");
 if(ASAP_Seek(asapc, (asapcur+a)*1000)==0) dlog(9,"oscp_asap_seek: failed");
}
/////##########################
void oscp_asap_parse(char *a) { lf("oscp_asap_parse"); char lmsg[4096];
// sprintf(lmsg,"ofparse start"); dlog(9,lmsg);
 int l=strlen(a); if(l<=0) { sprintf(lmsg,"ofparse: l==%d ?", l); dlog(9,lmsg); return; }
 if(strcmp(a,"q")==0 || strcmp(a,"quit")==0) { asap_end(); exit(0);
 } else if(strncmp(a,"loadfile ",9)==0) { oscp_asap_load(a+9);
 } else if(strncmp(a,"load ",5)==0) { oscp_asap_load(a+5);
 } else if(strncmp(a,"pause",5)==0) { asap_pause_toggle();
 } else if(strncmp(a,"get_property length",19)==0) {
  sprintf(lmsg, "ANS_length=%.1f\n", asapdur); cs(lmsg);
 } else if(strncmp(a,"get_property time_pos",19)==0 || strncmp(a,"get_time_pos",12)==0) {
//  sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0 0 0\n", asapcur); cs(lmsg);
 } else if(strncmp(a,"seek ",5)==0) { int o1=0;
  if(a[5]==*"-") { sscanf(a+6, "%d", &o1); o1*=-1; }
  else if(a[5]==*"+") { sscanf(a+6, "%d", &o1); }
  else { sscanf(a+5, "%d", &o1); }
  oscp_asap_seek(o1);
 } else if(strncmp(a,"vis ",4)==0) { sscanf(a+4, "%d", &vis);
 } else if(strncmp(a,"lfdump",5)==0) { lfdump();
 } else { sprintf(lmsg, "ofparse unhandled: %s", a); dlog(9, lmsg); }
 lf("oscp_asap_parse:finished");
}
/////######################### check stdin
void oscp_asap_check_input() { lf("oscp_asap_check_input");
 char lmsg[4096]; int i, rc; fd_set fsa;
 struct timeval *tvp=NULL; //, tv; tv.tv_sec=0; tv.tv_usec=10000*99; // i=(int)time(NULL);
 usleep(10000); FD_ZERO(&fsa); if(parent_said>=0) FD_SET(parent_said, &fsa);
 rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 if(rc<0) { if(0) { exit(EXIT_FAILURE); } else usleep(10000*99); }
 else if(rc==0) { }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==parent_said) { fdreadline(i, lmsg, 1020); oscp_asap_parse(lmsg); }
 }
 lf("oscp_asap_check_input:finished");
}
////##################
int oscp_asap_main() { lf("oscp_asap_main");
 cs("oscp-slave asap "ASAPInfo_VERSION"\n");
 lf("oscp_asap_main:asap_init");
 asap_init();
 lf("oscp_asap_main:while");
 while(1) { oscp_asap_check_input(); }
 lf("oscp_asap_main:asap_end");
 asap_end();
 lf("oscp_asap_main:finished");
 cs("EOF code: exit\n");
// lfdump();
 return 0;
}
