/*
 * oscp-slave-sc68.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include "oscp-slave.h"

#define _MSC_VER
#include <sc68/config_package68.h>
#include <sc68/api68/api68.h>

api68_init_t init68;
api68_t * sc68c = 0;
api68_music_info_t sc68I;
char sc68_buffer[512*4];

int sc68state=0; float sc68cur=0, sc68dur=0; int sc68i=0;
int sc68song=0;

/////################
void sc68_show_supp() {
 printf("  [slave-sc68]: based on sc68-"VERSION68"");
 printf(", formats: sc68, sndh\n");
}

/////###########
//void sc68_flush() { lf("sc68_flush"); adev_flush(); }
/////###########
void sc68_init() { lf("sc68_init"); sc68state=0; dlog(9, "sc68_init"); if(sc68state>0) return;

 if(sc68c) dlog(9, "sc68_init: sc68c not null?");
 memset(&init68, 0, sizeof(init68));
 // Set dynamic handler (required).
 init68.alloc = malloc; init68.free = free;
 // Set debug message handler (optionnal).
//init68.debug = vfprintf; init68.debug_cookie = stderr;
 sc68c=api68_init(&init68); if(!sc68c) { sc68state=0; return; }

 if(adev_init()<=0) { sc68state=0; return; }

 sc68state=1;
}
/////##########
void sc68_stop() { lf("sc68_stop");
 dlog(9, "sc68_stop");
 if(sc68state<=1) return;

 if(sc68state>=3) { 
  api68_close(sc68c);
 }

 sc68state=1;
}
/////#########
void sc68_end() { lf("sc68_end");
 dlog(9, "sc68_end"); if(sc68state>1) sc68_stop(); adev_end();
// if(sc68I) sc68Info_Delete(sc68I);
// if(sc68c) sc68_Delete(sc68c);
 api68_shutdown(sc68c);

 sc68state=0; 
}
/////##################
void sc68_die(char *msg) { lf2("sc68_die",msg); dlog(9, "sc68_die"); sc68_stop(); cs(msg); }

/////##########################
void sc68_update_info(char *fn) { lf("sc68_update_info"); static char lmsg[4096]; //int i;
 sc68song=api68_play(sc68c, -1); if(sc68song==0) { sc68song=1; api68_play(sc68c, sc68song); }

 sprintf(lmsg, "curr track: %d", sc68song); dlog(9,lmsg);

 if(api68_music_info(sc68c, &sc68I, -1, 0)!=0) { dlog(9,"api68_music_info failed"); return; }

 snprintf(lmsg,4095,"Artist: %s\n", sc68I.author); cs(lmsg);
 snprintf(lmsg,4095,"Title: %s (%s)\n", sc68I.title, get_basename(fn)); cs(lmsg);
// snprintf(lmsg,4095,"Year: %s\n", sc68I.year); cs(lmsg);

 int i=get_filesize(fn);
snprintf(lmsg,4095,"Comment: %d %d/%d, %s, %d%d%d %s, %s\n", i,
 sc68song,sc68I.tracks,sc68I.composer,
 sc68I.hw.ym,sc68I.hw.ste,sc68I.hw.amiga, sc68I.hwname, sc68I.replay
); cs(lmsg);

 sc68dur=sc68I.time_ms/1000.0; sprintf(lmsg, "ANS_length=%.1f\n", sc68dur); cs(lmsg);

 sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels, 0); cs(lmsg);

// sc68Info_Load(sc68c, const char *filename, unsigned char const *module, int moduleLen);
/*
int i;

i=sc68Info_GetYear(sc68I); if(i>0) { snprintf(lmsg,128,"Year: %d\n", i); cs(lmsg); }

//if(sc68mi.comment) snprintf(lmsg,4095,"Comment: %d, %d, %s, %s\n", fs, sc68mi.num_sequences,
// sc68mi.mod->type, sc68mi.comment);
//else snprintf(lmsg,4095,"Comment: %d, %d, %s\n", fs, sc68mi.num_sequences, sc68mi.mod->type); cs(lmsg);
*/

/*
struct sc68Info { int channels; int covoxAddr; int defaultSong; int fastplay; int headerLen;
 int init; int music; cibool ntsc; int player; int songs; sc68ModuleType type;
 unsigned char songPos[32]; char author[128]; char date[128]; int durations[32];
 char filename[128]; cibool loops[32]; char title[128]; };

sc68Info const *sc68_GetInfo(sc68 const *self);
sc68Info *sc68Info_New(void);
void sc68Info_Delete(sc68Info *self);
const char *sc68Info_GetAuthor(sc68Info const *self);
int sc68Info_GetChannels(sc68Info const *self);
const char *sc68Info_GetDate(sc68Info const *self);
//int sc68Info_GetDefaultSong(sc68Info const *self);
//int sc68Info_GetDuration(sc68Info const *self, int song); in ms
//int sc68Info_GetSongs(sc68Info const *self);
const char *sc68Info_GetTitleOrFilename(sc68Info const *self);
int sc68Info_GetYear(sc68Info const *self);
cibool sc68Info_IsNtsc(sc68Info const *self);
cibool sc68Info_Load(sc68Info *self, const char *filename, unsigned char const *module, int moduleLen);

 int fs=get_filesize(fn); sprintf(lmsg,"fs: %d",fs); dlog(9,lmsg);
 char *bn=rindex(fn, *"/"); if(!bn) bn=fn; else bn++;

 struct sc68_module_info sc68mi;
 sc68_get_module_info(sc68c, &sc68mi);
//snprintf(lmsg,4095,"sc68mi: md5: %s", sc68mi.md5); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: vol_base: %d", sc68mi.vol_base); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: comment: %s", sc68mi.comment); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: num_seq: %d", sc68mi.num_sequences); dlog(9,lmsg);
if(sc68mi.mod->name) { snprintf(lmsg,4095,"Title: %s\n", sc68mi.mod->name); cs(lmsg); }
if(bn) { snprintf(lmsg,4095,"Artist: %s\n", bn); cs(lmsg); }

if(sc68mi.comment) snprintf(lmsg,4095,"Comment: %d, %d, %s, %s\n", fs, sc68mi.num_sequences,
 sc68mi.mod->type, sc68mi.comment);
else snprintf(lmsg,4095,"Comment: %d, %d, %s\n", fs, sc68mi.num_sequences, sc68mi.mod->type); cs(lmsg);
//snprintf(lmsg,4095,"sc68mi: pat: %d", sc68mi.mod->pat); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: trk: %d", sc68mi.mod->trk); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: chn: %d", sc68mi.mod->chn); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: ins: %d", sc68mi.mod->ins); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: smp: %d", sc68mi.mod->smp); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: spd: %d", sc68mi.mod->spd); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: bpm: %d", sc68mi.mod->bpm); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: len: %d", sc68mi.mod->len); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: rst: %d", sc68mi.mod->rst); dlog(9,lmsg);
//snprintf(lmsg,4095,"sc68mi: gvl: %d", sc68mi.mod->gvl); dlog(9,lmsg);
 sprintf(lmsg, "AUDIO: %d Hz, %d ch, xxx, %d kbit\n", sformat.rate, sformat.channels,
  7); cs(lmsg);
*/

/*if(0==strcmp(tag->key,"artist")) { snprintf(lmsg,1022,"Artist: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"title")) { snprintf(lmsg,1022,"Title: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"album")) { snprintf(lmsg,1022,"Album: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"comment")) { snprintf(lmsg,1022,"Comment: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"genre")) { snprintf(lmsg,1022,"Genre  : %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"date")) { snprintf(lmsg,1022,"Year: %s\n",tag->value); cs(lmsg); }

  else if(0==strcmp(tag->key,"StreamTitle")) { snprintf(lmsg,1022,"Title: %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"icy-genre")) { snprintf(lmsg,1022,"Genre  : %s\n",tag->value); cs(lmsg); }
  else if(0==strcmp(tag->key,"icy-name")) { snprintf(lmsg,1022,"Comment: %s\n",tag->value); cs(lmsg); }
snprintf(lmsg, 1022, "sc68_update_info: %s=%s", tag->key, tag->value); dlog(9,lmsg);
*/
}

void sc68_play();
/////################################
void sc68_load(char *input_filename0) { lfd("sc68_load:state",sc68state);
 static char lmsg[4096]; lmsg[4095]=0;
 snprintf(lmsg, 4095, "Playing %s\n", input_filename0); cs(lmsg);

 if(input_filename0[0]==0) return;
 if(input_filename0[0]==*"\"" && input_filename0[1]==*"\"" && input_filename0[2]==0)
 { cs("EOF code: stop requested\n"); if(sc68state>2) sc68_stop(); return; }

 if(sc68state==0) sc68_init();
 else if(sc68state>2) sc68_stop();

 sc68state=2; sc68cur=0; sc68dur=0;
 char *input_filename=input_filename0;


 int sc68fs=get_filesize(input_filename);
 if(sc68fs<=0) { sc68_die("EOF code: invalid module size\n"); return; }

 if(api68_load_file(sc68c, input_filename)) {
  dlog(9,"sc68_load failed"); sc68_die("EOF code: api68_load_file failed\n"); return; }

// if(sc68I) sc68Info_Delete(sc68I);
// if(!sc68I) sc68I=(sc68Info *)sc68_GetInfo(sc68c);

 sfmt=AV_SAMPLE_FMT_S16;
      if(sfmt==AV_SAMPLE_FMT_U8 || sfmt==AV_SAMPLE_FMT_U8P){ sformat.bits=8; }
 else if(sfmt==AV_SAMPLE_FMT_S16 || sfmt==AV_SAMPLE_FMT_S16P){ sformat.bits=16; }
 else if(sfmt==AV_SAMPLE_FMT_S32 || sfmt==AV_SAMPLE_FMT_S32P){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_FLT || sfmt==AV_SAMPLE_FMT_FLTP){ sformat.bits=32; }
 else if(sfmt==AV_SAMPLE_FMT_DBL || sfmt==AV_SAMPLE_FMT_DBLP){ sformat.bits=64; }
 else { sc68_die("EOF code: Unsupported format\n"); return; }

//struct sc68Info { int channels; int covoxAddr; int defaultSong; int fastplay; int headerLen;
// int init; int music; cibool ntsc; int player; int songs; sc68ModuleType type;
// unsigned char songPos[32]; char author[128]; char date[128]; int durations[32];
// char filename[128]; cibool loops[32]; char title[128]; };

// if(sc68_PlaySong(sc68c, sc68Info_GetDefaultSong(sc68I), 360000)==0)
// { dlog(9, "sc68_load: sc68_PlaySong failed"); }
 // Set a track (optionnal).
 //api68_play(sc68, track);
 
 sc68cur=-1;
// sc68dur=sc68Info_GetDuration(sc68I, sc68Info_GetDefaultSong(sc68I))/1000.0;
// sprintf(lmsg, "ANS_length=%.1f\n", sc68dur); cs(lmsg);

 sformat.channels=2; sformat.rate=44100;
#ifdef LAO
 sformat.byte_format=AO_FMT_NATIVE; sformat.matrix=0;
#endif

 adev_setp(sformat.bits, &sformat.channels, &sformat.rate);

 sc68_update_info(input_filename);

 sc68state=3; sc68i=1;
 sc68_play();
}
void oscp_sc68_check_input();
void oscp_sc68_parse(char *a);
/////################# check messages
void sc68_check_input() { lf("sc68_check_input"); static char lmsg[4096]; static int rc;
 static fd_set sc68fsa;  static struct timeval sc68tv,*tvp;
 if(sc68state==4) { tvp=NULL; }
 else { sc68tv.tv_sec=0; sc68tv.tv_usec=1; tvp=&sc68tv; }

 FD_ZERO(&sc68fsa); if(parent_said>=0) FD_SET(parent_said, &sc68fsa);

 rc=select(FD_SETSIZE, &sc68fsa, NULL, NULL, tvp); if(rc==0) return;
 else if(rc<0) { sprintf(lmsg, "Info: sc68ci rc<0, %d, %s\n", errno, strerror(errno)); cs(lmsg); }
 else if(rc>0) // check if input is available
 { fdreadline(parent_said, lmsg, 1020); oscp_sc68_parse(lmsg); }
}
/////###################
void sc68_pause_toggle() { lf("sc68_pause_toggle");
      if(sc68state==3) { sc68state=4; cs("===== PAUSE =====\n");
  do { oscp_sc68_check_input(); } while(sc68state==4);
 }
 else if(sc68state==4) { sc68state=3; cs("===== RESUME =====\n"); }
 else cs("Info: pause called but sc68state != (3 || 4)"); }

/////##############
void sc68_checksd() {}
/////##############
void sc68_checkmd() {}

// decode buffer
unsigned char sc68_dbuf[1024*192];

/////###########
void sc68_play() { lf("sc68_play"); dlog(9, "sc68_play");
 if(sc68state!=3) { cs("EOF code: can't play, not inited\n"); return; }
 int t1=0,ot1=-1; // sc68cur=0; sc68dur=0;
 static char lmsg[128];
 void *buf[1];

//dlog(9,"DIIING");
//int gb=api68_process(sc68c, sc68_buffer, sizeof(sc68_buffer) >> 2);
//sprintf(lmsg,"play:state: %d,%d,%d", gb, API68_END, gb&API68_END); dlog(9,lmsg);
//dlog(9,api68_error());


//#define API68_IDLE_BIT   1 /**< Set if no emulation pass has been runned. */
//#define API68_CHANGE_BIT 2 /**< Set when track has changed.               */
//#define API68_LOOP_BIT   4 /**< Set when track has loop.                  */
//#define API68_END_BIT    5 /**< Set when finish with all tracks.          */

//#define API68_IDLE       (1<<API68_IDLE_BIT)   /**< @see API68_IDLE_BIT   */
//#define API68_CHANGE     (1<<API68_CHANGE_BIT) /**< @see API68_CHANGE_BIT */
//#define API68_LOOP       (1<<API68_LOOP_BIT)   /**< @see API68_LOOP_BIT   */
//#define API68_END        (1<<API68_END_BIT)    /**< @see API68_END_BIT    */

//#define API68_MIX_OK     0  /**< Not really used. */
//#define API68_MIX_ERROR  -1 /**< Error.           */


 while(sc68state==3 && !(api68_process(sc68c, sc68_buffer, sizeof(sc68_buffer) >> 2) & API68_END))
 {
//sprintf(lmsg,"gb: %d, gb/4:%d", gb, gb/4); dlog(9,lmsg);
//dlog(9,"DOOONG");


  t1=api68_seek(sc68c,-1)/1000; if(t1!=ot1)
  { ot1=t1; sc68cur=t1; sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0\n", sc68cur); cs(lmsg);

//   if(sc68dur==0) { sc68dur=sc68fi.total_time/1000.0; sprintf(lmsg, "ANS_length=%.1f\n", sc68dur); cs(lmsg); }
  }

//int     sc68_Generate(sc68 *self, unsigned char *buffer, int bufferLen, sc68SampleFormat format);

//  buf[0]=sc68_dbuf;
  buf[0]=sc68_buffer;
  adev_out(buf, sizeof(sc68_buffer)/2/sformat.channels, sformat.channels, sfmt);

#if 0
if(0&&ot2==1) { // static char lmsg[1024]; sprintf(lmsg,
 "Info: fmt:%s, ch:%d, bi:%d, ra:%d, len:%d, plane_size: %d",
 lfmt, sformat.channels, sformat.bits, sformat.rate, len, plane_size); dlog(9,lmsg); }
#endif

  sc68i++; sc68_check_input();
 }
 

 adev_close();
 sc68_die("EOF code: finished decoding\n");
 lf("sc68_play:finished");
}

/////##########################
void oscp_sc68_load(char *fn) { lf("oscp_sc68_load");
 sc68_load(fn); //sc68_play();
 lf("oscp_sc68_load:finished");
}
/////####################
void oscp_sc68_seek(int a) { lf("oscp_sc68_seek");
 int o=sc68song;
 if(a>=0) { sc68song++; if(sc68song>sc68I.tracks) sc68song=sc68I.tracks; }
 else { sc68song--; if(sc68song<1) sc68song=1; }
 if(o!=sc68song) {
char lmsg[1024]; sprintf(lmsg, "oscp_sc68_seek: switch to song %d", sc68song); dlog(9,lmsg);
 api68_play(sc68c, sc68song);
 sc68_update_info(NULL);
}

/*
// int t=(int)((sc68cur+a)*1000.0);
// int t=1+sc68dur*1000.0;
 int t=1;
 int r;
 r=api68_seek(sc68c, t);
 if(r<0) dlog(9,lmsg);
// dlog(9,"oscp_sc68_seek: failed");
*/
}
/////##########################
void oscp_sc68_parse(char *a) { lf("oscp_sc68_parse"); char lmsg[4096];
// sprintf(lmsg,"ofparse start"); dlog(9,lmsg);
 int l=strlen(a); if(l<=0) { sprintf(lmsg,"ofparse: l==%d ?", l); dlog(9,lmsg); return; }
 if(strcmp(a,"q")==0 || strcmp(a,"quit")==0) { sc68_end(); exit(0);
 } else if(strncmp(a,"loadfile ",9)==0) { oscp_sc68_load(a+9);
 } else if(strncmp(a,"load ",5)==0) { oscp_sc68_load(a+5);
 } else if(strncmp(a,"pause",5)==0) { sc68_pause_toggle();
 } else if(strncmp(a,"get_property length",19)==0) {
  sprintf(lmsg, "ANS_length=%.1f\n", sc68dur); cs(lmsg);
 } else if(strncmp(a,"get_property time_pos",19)==0 || strncmp(a,"get_time_pos",12)==0) {
//  sprintf(lmsg, "A: %.1f 0 0 0 0 0 0 0 0 0\n", sc68cur); cs(lmsg);
 } else if(strncmp(a,"seek ",5)==0) { int o1=0;
  if(a[5]==*"-") { sscanf(a+6, "%d", &o1); o1*=-1; }
  else if(a[5]==*"+") { sscanf(a+6, "%d", &o1); }
  else { sscanf(a+5, "%d", &o1); }
  oscp_sc68_seek(o1);
 } else if(strncmp(a,"vis ",4)==0) { sscanf(a+4, "%d", &vis);
 } else if(strncmp(a,"lfdump",5)==0) { lfdump();
 } else { sprintf(lmsg, "ofparse unhandled: %s", a); dlog(9, lmsg); }
 lf("oscp_sc68_parse:finished");
}
/////######################### check stdin
void oscp_sc68_check_input() { lf("oscp_sc68_check_input");
 char lmsg[4096]; int i, rc; fd_set fsa;
 struct timeval *tvp=NULL; //, tv; tv.tv_sec=0; tv.tv_usec=10000*99; // i=(int)time(NULL);
 usleep(10000); FD_ZERO(&fsa); if(parent_said>=0) FD_SET(parent_said, &fsa);
 rc=select(FD_SETSIZE, &fsa, NULL, NULL, tvp); // block till input

 if(rc<0) { if(0) { exit(EXIT_FAILURE); } else usleep(10000*99); }
 else if(rc==0) { }
 else for(i=0; i<FD_SETSIZE; ++i) if(FD_ISSET(i, &fsa)) {
  if(i==parent_said) { fdreadline(i, lmsg, 1020); oscp_sc68_parse(lmsg); }
 }
 lf("oscp_sc68_check_input:finished");
}
////################
int oscp_sc68_main() { lf("oscp_sc68_main");
 cs("DING\n");
 cs("oscp-slave sc68 "VERSION68"\n");
 lf("oscp_sc68_main:sc68_init");
 sc68_init();
 lf("oscp_sc68_main:while");
 while(1) { oscp_sc68_check_input(); }
 lf("oscp_sc68_main:sc68_end");
 sc68_end();
 lf("oscp_sc68_main:finished");
 cs("EOF code: exit\n");
// lfdump();
 return 0;
}
